﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace KB8267_SampleApp1
{
    public partial class WebForm1 : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if(Session["data"] == null)
            {
                Session["data"] = GetData();
            }
            WebDataGrid1.DataSource = Session["data"];
        }

        private DataTable GetData()
        {
            DataTable dt = new DataTable();

            // Columns
            dt.Columns.Add("ID", typeof(int));
            dt.Columns.Add("FamilyName", typeof(String));
            dt.Columns.Add("GivenName", typeof(String));
            dt.Columns.Add("Age", typeof(int));

            // Rows
            Random rnd = new Random();
            String[] familyNames = new String[] { "土田", "矢田", "吉村", "安田", "矢野", "小村", "柳川", "市村", "園田", "角", "中原", "岸田", "粕谷", "竹原", "脇田", "福地", "山岡", "大平", "西田", "室井", "池谷", "野崎", "白木", "細井", "中西", "湯浅", "金丸", "黒田", "長谷川", "加瀬", "船橋", "植松", "新倉", "中山", "高倉", "熊田", "小島", "水田", "田島", "玉城", "鶴田", "田沢", "吉田", "高原", "関谷", "鹿野", "迫田", "熊谷", "坂口", "栗原" };
            String[] givenNames = new string[] { "美名子", "眞", "紗彩", "美南", "優芽", "珠希", "直美", "薫", "琉奈", "成良", "幸次", "明彦", "清舟", "柚衣", "夏実", "彩乃", "奈緒子", "正美", "善雄", "辰雄", "正信", "孝男", "晴奈", "咲月", "精一", "清次郎", "茂夫", "栄蔵", "敏男", "雅博", "竜太", "守友", "直吉", "愛輝", "幸一郎", "金太郎", "真美", "琴乃", "康男", "貞行", "春花", "栄太郎", "果音", "智恵", "順一", "梨花", "美穂", "真樹", "愛理", "真紗子" };
            for (int i = 0; i < 5; i++)
            {
                int familyNameIndex = rnd.Next(familyNames.Length);
                int givenNameIndex = rnd.Next(givenNames.Length);
                int age = rnd.Next(20, 80);

                dt.Rows.Add(new object[] { i, familyNames[familyNameIndex], givenNames[givenNameIndex], age });
            }

            // Primary key
            dt.PrimaryKey = new DataColumn[] { dt.Columns["ID"] };

            return dt;
        }

        protected void Button1_Click(object sender, EventArgs e)
        {
            // 0行目のName欄のテキストを取得する。
            String familyName = (WebDataGrid1.Rows[0].Items[1].FindControl("FamilyNameLabel") as Label)?.Text;
            String givenName = (WebDataGrid1.Rows[0].Items[1].FindControl("GivenNameLabel") as Label)?.Text;

            System.Diagnostics.Debug.WriteLine("FamilyName=" + familyName + ", GivenName=" + givenName);
        }
    }
}